(***********************************************************************)
(*                                                                     *)
(*                          OcamlQuake 0.1                             *)
(*                                                                     *)
(*                         Francois Pessaux                            *)
(*                                                                     *)
(*  Copyright 1998                                                     *)
(*  This code can be re-used or modified without any restriction.      *)
(*  This version is still under development, there may be bugs and     *)
(*  inefficient stuff, and I will not be responsible of what can       *)
(*  happen to you and your environment if you use, read or do          *)
(*  whatever you want with all this... Enjoy...                        *)
(*                                                                     *)
(***********************************************************************)


val numentities: int ref
val entities: Qheader.entity_t array ref ;;
val nummodels: int ref
val models: Qheader.model_t array ref
val numnodes: int ref
val nodes: Qheader.node_t array ref
val numplanes: int ref
val planes: Qheader.plane_t array ref
val numleaves: int ref
val leaves: Qheader.dleaf_t array ref
val numvisilists: int ref
val visilists: string ref
val numlfaces: int ref
val lfaces: int array ref
val numfaces: int ref
val faces: Qheader.face_t array ref
val numclipnodes: int ref
val clipnodes: Qheader.clipnode_t array ref
val numledges: int ref
val ledges: int array ref
val numedges: int ref
val edges: Qheader.edge_t array ref
val numvertices: int ref
val vertices: Qheader.vertex_t array ref
val numsurfaces: int ref
val surfaces: Qheader.surface_t array ref
val nummiptexs: int ref
val miptexs: Gr.tex_info array ref
val mipaddrs: int array ref
val texture_scaling: float array ref

val visible_leaves: bool array ref
val visible_nodes: bool array ref
val visible_faces: bool array ref

val camera: Camera.camera
val frustum: Frustum.frustum
val dummy_glide_vertex: Gr.vertex
val dummy_model: Qheader.model_t

val coldet_active: bool ref

