(***********************************************************************)
(*                                                                     *)
(*                          OcamlQuake 0.1                             *)
(*                                                                     *)
(*                         Francois Pessaux                            *)
(*                                                                     *)
(*  Copyright 1998                                                     *)
(*  This code can be re-used or modified without any restriction.      *)
(*  This version is still under development, there may be bugs and     *)
(*  inefficient stuff, and I will not be responsible of what can       *)
(*  happen to you and your environment if you use, read or do          *)
(*  whatever you want with all this... Enjoy...                        *)
(*                                                                     *)
(***********************************************************************)


let r_long filehd =
 let b0 = input_byte filehd in
 let b1 = input_byte filehd in
 let b2 = input_byte filehd in
 let b3 = input_byte filehd in
 (b3 lsl 24) + (b2 lsl 16) + (b1 lsl 8) + b0
;;


let r_float filehd =
 let b0 = input_byte filehd in
 let b1 = input_byte filehd in
 let b2 = input_byte filehd in
 let b3 = input_byte filehd in
 Floatio.ml_double_from_4_bytes b0 b1 b2 b3
;;


let extend_short_sign x =
  if 0x8000 land x <> 0 then 0xffff0000 lor x else x
;;


let r_short filehd =
 let b0 = input_byte filehd in
 let b1 = input_byte filehd in
 extend_short_sign ((b1 lsl 8) + b0)
;;


let r_byte = input_byte ;;


let r_string_fixed num filehd =
  let r = String.create num in
  for i = 0 to num - 1 do
    r.[i] <- Char.chr (r_byte filehd)
  done ;
  r
;;
