(***********************************************************************)
(*                                                                     *)
(*                          OcamlQuake 0.1                             *)
(*                                                                     *)
(*                         Francois Pessaux                            *)
(*                                                                     *)
(*  Copyright 1998                                                     *)
(*  This code can be re-used or modified without any restriction.      *)
(*  This version is still under development, there may be bugs and     *)
(*  inefficient stuff, and I will not be responsible of what can       *)
(*  happen to you and your environment if you use, read or do          *)
(*  whatever you want with all this... Enjoy...                        *)
(*                                                                     *)
(***********************************************************************)


type matrix3x3 =
  { mutable m11: float;    mutable m12: float;
    mutable m13: float;    mutable m21: float;    mutable m22: float;
    mutable m23: float;
    mutable m31: float;
    mutable m32: float;
    mutable m33: float }

val identity_matrix : unit -> matrix3x3
val mult_matrices : matrix3x3 -> matrix3x3 -> matrix3x3 -> unit
val fill_ry_matrix : float -> matrix3x3 -> unit
val fill_rz_matrix : float -> matrix3x3 -> unit
val reset_matrix : matrix3x3 -> unit
val transpose_matrix : matrix3x3 -> matrix3x3 -> unit
