open Qheader ;;
open Math ;;

type camera = {
  position : vec3_t ;
  (* Matrice representant la rotation qu'a subi le joueur *)
  rotation : Matrix.matrix3x3 ;
  (* Matrice representant la rotation opposee de celle qu'a subi le joueur *)
  (* Sert a transformer les objets dans le repere view-space *)
  irotation : Matrix.matrix3x3
  } ;;


let vertex_to_camera_space camera { vx = vx ; vy = vy ; vz = vz } =
  let vx' = vx -. camera.position.x in
  let vy' = vy -. camera.position.y in
  let vz' = vz -. camera.position.z in
  vertex_rotate { vx = vx' ; vy = vy' ; vz = vz' } camera.irotation
;;

