open Printf ;;
open Qheader ;;


let print_vec3 { x = x ; y = y ; z = z } =
  Printf.printf "{ x = %f ; y = %f ; z = %f }\n" x y z
;;


let print_entry { offset = offset ; size = size } =
  printf "{ Entry offset: %d   Entry size: %d }\n" offset size
;;


let print_header
  { version = version ; entities = entities_entry ; planes = planes_entry ;
    miptex = miptex_entry ; vertices = vertices_entry ;
    visilist = visilist_entry ; nodes = nodes_entry ; texinfo = texinfo_entry ;
    faces = faces_entry ; lightmaps = lightmaps_entry ;
    clipnodes = clipnodes_entry ; leaves = leaves_entry ;
    lfaces = lfaces_entry ; edges = edges_entry ; ledges = ledges_entry ;
    models = models_entry } =
  printf "Version: %d\n" version ;
  printf "Entities entry: " ; print_entry entities_entry ;
  printf "Planes entry: " ; print_entry planes_entry ;
  printf "Miptex entry: " ; print_entry miptex_entry ;
  printf "Vertices entry: " ; print_entry vertices_entry ;
  printf "Visilist entry: " ; print_entry visilist_entry ;
  printf "Nodes entry: " ; print_entry nodes_entry ;
  printf "Texinfo entry: " ; print_entry texinfo_entry ;
  printf "Faces entry: " ; print_entry faces_entry ;
  printf "Lightmaps entry: " ; print_entry lightmaps_entry ;
  printf "Clipnodes entry: " ; print_entry clipnodes_entry ;
  printf "Leaves entry: " ; print_entry leaves_entry ;
  printf "Lfaces entry: " ; print_entry lfaces_entry ;
  printf "Edges entry: " ; print_entry edges_entry ;
  printf "Ledges entry: " ; print_entry ledges_entry ;
  printf "Models entry: " ; print_entry models_entry
;;

